#!/usr/bin/env python
# _*_ coding: iso-8859-15 _*_

import wx, os, time

import _winreg
import shutil
import time

import win32api as wa

from platform import release
from ConfigParser import ConfigParser

from lance_cmd import lancecmd



class cliScribeInst:
    def __init__(self, parent):
        self.parent = parent
        # fichier d'initialistaion
        self.conf_f = 'install.ini'
        # fichier setup
        self.setup = 'cliscribe-updater-setup.exe'
        #dtection OS et initialisation
        self.type_os = release().lower()
        if self.type_os in ['xp', '2000']:
            self.type_os = 'xp'
        elif self.type_os in ['95', '98', 'me']:
            self.type_os = '9x'
        #rpertoire d'installation "WINDIR\Eole"
        self.windir = os.environ['windir']
        self.dir = os.path.join(self.windir, 'Eole')
        # rcupration des valeurs
        self.get_values()

    #######################
    ##    Installation   ##
    #######################
    def install(self, silent=None):
        """
        Ajout des cl dans la base de registre :
            HKEY_LOCAL_MACHINE\Software\Eole\Scribe
            - inst_path
            - ip_scribe
            - port_scribe_update
        """
        # cration du rpertoire et copie de install.ini
        if not os.path.isdir(self.dir): os.makedirs(self.dir)
        dst = os.path.join(self.dir, self.conf_f)
        shutil.copy(self.conf_f, dst)
        args = self.inst_args
        args += ' /inst_args="%s"'%self.inst_args
        if silent: args += ' /SUPPRESSMSGBOXES'
        lancecmd('%s %s'%(self.setup, args))
        # Lancement de la mise  jour sans redmarrage auto (-ns)
        cmd = os.path.join(self.dir, 'updater', 'updater.exe -ns')
        lancecmd(cmd)
##        cmd = os.path.join(self.dir, 'cliscribe', 'logon.exe')
##        if os.path.isfile(cmd) and self.type_os == 'xp':
##            wa.WinExec(cmd)

    ##########################
    ##    DsInstallation   ##
    ##########################
    def uninstall(self, silent=None):
        """dsintallation de l'ancien cliscribe
        redmarrage auto si silent=True
        """
        # client Scribe InnoSetup
        # UninstallString est entour de guillemets, il faut faire un eval()
        old = self.get_reg_value('HKEY_LOCAL_MACHINE', r'Software\Microsoft\Windows\CurrentVersion\Uninstall\CliScribe_is1', 'UninstallString')
        # service MAJ
        old_updt = self.get_reg_value('HKEY_LOCAL_MACHINE', r'Software\Microsoft\Windows\CurrentVersion\Uninstall\CliScribe-updater_is1', 'UninstallString')
        # ancienne version
        old_path = os.path.join(os.environ['windir'], 'Eole')
        # cas de l'installeur InnoSetup
        if old_updt:
            cmd = eval(old_updt)
            args = '/SILENT /NORESTART'
            if silent: args += ' /SUPPRESSMSGBOXES'
            ret = lancecmd('%s %s'%(cmd, args))
            if ret != 0:
                msg = u'Dsinstallation %s echoue (code retour %s)'%(cmd, ret)
                raise Exception, msg
        if old:
            cmd = eval(old)
            args = ' /SILENT'# /NORESTART'
            if silent: args += ' /SUPPRESSMSGBOXES'
            ret = lancecmd('%s %s'%(cmd, args))
            if ret != 0:
                msg = u'Dsinstallation %s echoue (code retour %s)'%(cmd, ret)
                raise Exception, msg
        # sinon client Scribe installXP/9x.bat
        elif os.path.isdir(old_path):
            if self.type_os == 'xp':
                netcmd = os.path.join(os.environ['WINDIR'], 'system32', 'net.exe')
                sccmd = os.path.join(os.environ['WINDIR'], 'system32', 'sc.exe')
                lancecmd('%s stop servscribe'%netcmd, hide=True)
                lancecmd('%s stop winvnc'%netcmd, hide=True)
                time.sleep(1)
                lancecmd('%s delete servscribe'%sccmd, hide=True, nowait=True)
                lancecmd('%s delete winvnc'%sccmd, hide=True, nowait=True)
            # windows 9x
            else:
                cmd = os.path.join(old_path, 'winvnc.exe')
                lancecmd('%s %s'%(cmd, '-kill'), hide=True)
                time.sleep(1)
                lancecmd('%s %s'%(cmd, '-remove'), hide=True, nowait=True)
                time.sleep(2)
        try: shutil.rmtree(old_path)
        except: pass
        try: _winreg.DeleteKey(_winreg.HKEY_LOCAL_MACHINE, r'Software\Eole\Scribe')
        except: pass
        try: _winreg.DeleteKey(_winreg.HKEY_LOCAL_MACHINE, r'Software\Eole')
        except: pass


    ########################
    ## Fonctions Diverses ##
    ########################
    def get_values(self):
        """rcupration des valeurs  passer en argument  l'installeur InnoSetup
        """
        self.inst_args = self.get_option('global', 'inst_args')

    def get_option(self, section, var):
        c = ConfigParser()
        c.read(self.conf_f)
        res = c.get(section, var)
        return res.strip()


    def get_reg_value(self, key, path, name):
        """rcupre la valeur de
        key\path:name
        dans la Base De Registre
        """
        skey = getattr(_winreg, key)
        try:
            hkey = _winreg.OpenKey(skey, path)
            #rcupration du chemin d'installation du service "os.curdir" fonctionne pas pour un service NT
            return _winreg.QueryValueEx(hkey, name)[0]
        except Exception, e:
            return None

    def AdjustPrivilege(self, enable = 1):
        """sous windows, redmarrer est un privilge ...
        """
        import win32security as wsec
        import ntsecuritycon as ntsec
        self.privileges = [ntsec.SE_BACKUP_NAME, ntsec.SE_SHUTDOWN_NAME]
        for priv in self.privileges:
            # Get the process token.
            flags = ntsec.TOKEN_ADJUST_PRIVILEGES | ntsec.TOKEN_QUERY
            htoken = wsec.OpenProcessToken(wa.GetCurrentProcess(), flags)
            # Get the ID for the system shutdown privilege.
            id = wsec.LookupPrivilegeValue(None, priv)
            # Now obtain the privilege for this process.
            # Create a list of the privileges to be added.
            if enable:
                newPrivileges = [(id, ntsec.SE_PRIVILEGE_ENABLED)]
            else:
                newPrivileges = [(id, 0)]
            # and make the adjustment.
            wsec.AdjustTokenPrivileges(htoken, 0, newPrivileges)

    def RebootServer(self, message="", timeout=0, bForce=0, bReboot=1):
        if self.type_os == 'xp':
            cmd = os.path.join(os.environ['WINDIR'], 'system32', 'shutdown.exe')
            lancecmd('%s -r -f -t 0'%cmd, hide=True)
            self.AdjustPrivilege()
            while True:
                try:
                    wa.InitiateSystemShutdown(None, message, timeout, bForce, bReboot)
                    break
                except: continue
                time.sleep(0.5)
        elif self.type_os == '9x':
            wa.ExitWindowsEx(2,0)

