#!/usr/bin/env python
# _*_ coding: iso-8859-1 _*_


import logging, re
import win32print as wp
import win32api as wa
from reg import get_option

# LImprimantes
# SetDefautPrinter
# DelNotInList

MACHINE = wa.GetComputerName()

def liste_printers():
    """Liste les imprimantes connectes depuis le rseau
    """
    liste = [i[2] for i in wp.EnumPrinters(wp.PRINTER_ENUM_CONNECTIONS)]
    return liste

def remove_printers():
    """Dsinstalle les imprimantes si paramtr dans Esu
    """
    if get_option(r'Software\CRDP Bretagne\esu', 'DelNotInList', 'HKEY_CURRENT_USER') == '1':
        logging.info('Dsinstallation des imprimantes non gres')
        for printer in liste_printers():
            logging.info('Dsinstallation de "%s"'%printer)
            wp.DeletePrinterConnection(printer)

def get_esu_printers():
    return get_option(r'Software\CRDP Bretagne\esu', 'LImprimantes', 'HKEY_CURRENT_USER')

def install_printers():
    remove_printers()
    printers = get_esu_printers()
    if not printers: return
    for printer in printers.split(','):
        if test_printer(printer):
            try:
                wp.AddPrinterConnection(printer)
                logging.info('Imprimante "%s" installe'%printer)
            except Exception, e: logging.error("""Erreur de connexion de l'imprimante %s, erreur : "%s" """%(printer, e))
        else: logging.info('"%s" est une imprimante locale'%printer)
    setdefault()

def setdefault():
    printers = get_esu_printers()
    if get_option(r'Software\CRDP Bretagne\esu', 'SetDefautPrinter', 'HKEY_CURRENT_USER') == '1' and printers:
        printer = printers.split(',')[0]
        logging.info("""Dfinition de l'imprimante "%s" par dfaut"""%printer)
        wp.SetDefaultPrinter(printer)

def test_printer(printer):
    regexp = r'\\\\([^\\]+)\\'
    res = re.match(regexp, printer.strip())
    if not res: return False
    if res.group(1).upper() == MACHINE.upper(): return False
    return True
